diff -r -uw -N irrlicht/include/EDriverTypes.h irrlicht_multipatch/include/EDriverTypes.h
--- irrlicht/include/EDriverTypes.h	2006-09-24 11:31:06.000000000 +0200
+++ irrlicht_multipatch/include/EDriverTypes.h	2006-11-30 17:22:12.000000000 +0100
@@ -42,6 +42,10 @@
 		//! Win2K, WinXP. Performs hardware accelerated rendering of 3D and 2D primitives.
 		EDT_DIRECT3D9,
 
+		//! Direct3D 9 multihead device, only available on Win32 platforms including Win95, Win98, WinNT,
+		//! Win2K, WinXP.
+		EDT_DIRECT3D9_MULTIHEAD,
+
 		//! OpenGL device, available on all Win32 platforms and on Linux.
 		//! Performs hardware accelerated rendering of 3D and 2D primitives.
 		EDT_OPENGL    
diff -r -uw -N irrlicht/include/IEventReceiver.h irrlicht_multipatch/include/IEventReceiver.h
--- irrlicht/include/IEventReceiver.h	2006-11-11 09:29:20.000000000 +0100
+++ irrlicht_multipatch/include/IEventReceiver.h	2006-12-01 13:16:06.000000000 +0100
@@ -116,6 +116,9 @@
 			//! In an editbox was pressed 'ENTER'
 			EGET_EDITBOX_ENTER,
 
+			//! In a edit box was press a key
+			EGET_EDITBOX_KEY_PRESS,
+
 			//! The tab was changed in an tab control
 			EGET_TAB_CHANGED,
 
@@ -123,7 +126,10 @@
 			EGET_MENU_ITEM_SELECTED,
 
 			//! The selection in a combo box has been changed
-			EGET_COMBO_BOX_CHANGED
+			EGET_COMBO_BOX_CHANGED,
+
+			//! The window has closed
+			EGET_WINDOW_CLOSED
 		};
 	} // end namespace gui
 
diff -r -uw -N irrlicht/include/IGUIContextMenu.h irrlicht_multipatch/include/IGUIContextMenu.h
--- irrlicht/include/IGUIContextMenu.h	2006-06-17 08:12:14.000000000 +0200
+++ irrlicht_multipatch/include/IGUIContextMenu.h	2006-11-30 12:36:04.000000000 +0100
@@ -38,7 +38,7 @@
 		 at this item. You can acess this submenu via getSubMenu().
 		 \return Returns the index of the new item */
 		virtual s32 addItem(const wchar_t* text, s32 commandId=-1, bool enabled=true,
-			bool hasSubMenu=false) = 0;
+			bool hasSubMenu=false, bool checked=false) = 0;
 
 		//! Adds a separator item to the menu
 		virtual void addSeparator() = 0;
@@ -61,6 +61,15 @@
 		 \param enabled: True if it is enabled, otherwise false. */
 		virtual void setItemEnabled(s32 idx, bool enabled) = 0;
 
+		//! Returns if a menu item is checked
+		/** \param idx: Zero based index of the menu item */
+		virtual bool isItemChecked(s32 idx) = 0;
+
+		//! Sets if the menu item should be checked.
+		/** \param idx: Zero based index of the menu item
+		 \param enabled: True if it is checked, otherwise false. */
+		virtual void setItemChecked(s32 idx, bool checked) = 0;
+
 		//! Removes a menu item
 		/** \param idx: Zero based index of the menu item */
 		virtual void removeItem(s32 idx) = 0;
diff -r -uw -N irrlicht/include/IMaterialRenderer.h irrlicht_multipatch/include/IMaterialRenderer.h
--- irrlicht/include/IMaterialRenderer.h	2006-06-21 08:16:08.000000000 +0200
+++ irrlicht_multipatch/include/IMaterialRenderer.h	2006-11-30 16:54:58.000000000 +0100
@@ -87,6 +87,14 @@
 	Fixed function pipeline materials should return 0 in most cases, parallax mapped
 	material will only return 0 when at least pixel shader 1.4 is available on that machine. */
 	virtual s32 getRenderCapability() { return 0; }
+
+	//!Sets a device adapter index number
+	virtual void setRenderDevice(s32 deviceIdx = 0)
+	{
+		deviceIndex = deviceIdx;
+	}
+protected:
+	u32 deviceIndex;
 };
 
 
diff -r -uw -N irrlicht/include/IMeshBuffer.h irrlicht_multipatch/include/IMeshBuffer.h
--- irrlicht/include/IMeshBuffer.h	2006-08-29 08:12:58.000000000 +0200
+++ irrlicht_multipatch/include/IMeshBuffer.h	2006-11-29 21:51:46.000000000 +0100
@@ -80,10 +80,10 @@
 		virtual s32 getVertexCount() const = 0;
 
 		//! returns pointer to Indices
-		virtual const u16* getIndices() const = 0;
+		virtual const u32* getIndices() const = 0;
 
 		//! returns pointer to Indices
-		virtual u16* getIndices() = 0;
+		virtual u32* getIndices() = 0;
 
 		//! returns amount of indices
 		virtual s32 getIndexCount() const = 0;
diff -r -uw -N irrlicht/include/ISceneManager.h irrlicht_multipatch/include/ISceneManager.h
--- irrlicht/include/ISceneManager.h	2006-11-11 09:31:16.000000000 +0100
+++ irrlicht_multipatch/include/ISceneManager.h	2006-12-03 16:20:12.000000000 +0100
@@ -777,6 +777,13 @@
 		virtual void registerNodeForRendering(ISceneNode* node,
 			E_SCENE_NODE_RENDER_PASS pass = ESNRP_AUTOMATIC) = 0;
 
+		//! Update effects of all the scene nodes.
+		/** This can only be invoked between
+		 IVideoDriver::beginScene() and IVideoDriver::endScene(). Please note that
+		 the scene is not only drawn when calling this, but also animated
+		 by existing scene node animators, culling of scene nodes is done, etc. */
+		virtual void updateEffects() = 0;
+
 		//! Draws all the scene nodes.
 		/** This can only be invoked between
 		 IVideoDriver::beginScene() and IVideoDriver::endScene(). Please note that
@@ -828,7 +835,7 @@
 		 If you no longer need the animator, you should call ISceneNodeAnimator::drop().
 		 See IUnknown::drop() for more information. */
 		virtual ISceneNodeAnimator* createTextureAnimator(const core::array<video::ITexture*>& textures,
-			s32 timePerFrame, bool loop=true) = 0;
+			s32 timePerFrame, bool loop=true, s32 layer=0) = 0;
 
 		//! Creates a scene node animator, which deletes the scene node after some time automatically.
 		/** \param timeMs: Time in milliseconds, after when the node will be deleted.
diff -r -uw -N irrlicht/include/ISceneNode.h irrlicht_multipatch/include/ISceneNode.h
--- irrlicht/include/ISceneNode.h	2006-10-15 08:48:52.000000000 +0200
+++ irrlicht_multipatch/include/ISceneNode.h	2006-12-03 16:30:56.000000000 +0100
@@ -66,6 +66,18 @@
 		}
 
 
+		//! This method is called just before the whole rendering process of the whole scene.
+		//! not calling their OnUpdateEffect-Method.
+		virtual void OnUpdateEffect()
+		{
+			if (IsVisible)
+			{
+				core::list<ISceneNode*>::Iterator it = Children.begin();
+				for (; it != Children.end(); ++it)
+					(*it)->OnUpdateEffect();
+			}
+		}
+
 		//! This method is called just before the rendering process of the whole scene.
 		//! Nodes may register themselves in the render pipeline during this call,
 		//! precalculate the geometry which should be renderered, and prevent their
diff -r -uw -N irrlicht/include/ITerrainSceneNode.h irrlicht_multipatch/include/ITerrainSceneNode.h
--- irrlicht/include/ITerrainSceneNode.h	2006-10-15 08:48:56.000000000 +0200
+++ irrlicht_multipatch/include/ITerrainSceneNode.h	2006-12-01 14:46:08.000000000 +0100
@@ -67,6 +67,9 @@
 		//! Returns pointer to the mesh
 		virtual IMesh* getMesh() = 0;
 
+		//!a helper function to destroy the meshbuffer.
+		virtual void destroyMeshBuffer(SMeshBufferLightMap& mb) = 0;
+
 		//! Gets the meshbuffer data based on a specified level of detail.
 		/** \param mb: A reference to an SMeshBuffer object
 		 \param LOD: the level of detail you want the indices from. */
diff -r -uw -N irrlicht/include/IVideoDriver.h irrlicht_multipatch/include/IVideoDriver.h
--- irrlicht/include/IVideoDriver.h	2006-11-25 13:46:54.000000000 +0100
+++ irrlicht_multipatch/include/IVideoDriver.h	2006-12-05 11:50:56.000000000 +0100
@@ -165,7 +165,7 @@
 		/** Returns true if a feature is available
 		\param feature: A feature to query.
 		\return Returns true if the feature is available, false if not. */
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature) = 0;
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1) = 0;
 
 		//! Sets the view, world or projection transformation.
 		/* \param state: Transformation type to be set. Can be view, world or projection.
@@ -360,7 +360,7 @@
 		\param triangleCount: amount of Triangles.
 		\param vType: Vertex type, e.g. EVT_STANDARD for S3DVertex.
 		\param pType: Primitive type, e.g. EPT_TRIANGLE_FAN for a triangle fan. */
-		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType) = 0;
+		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType) = 0;
 
 		//! Draws an indexed triangle list.
 		/** Note that there may be at maximum 65536 vertices, because the
@@ -372,7 +372,7 @@
 		\param indexList: Pointer to array of indizes.
 		\param triangleCount: amount of Triangles. Usually amount of indizes / 3. */
 		virtual void drawIndexedTriangleList(const S3DVertex* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+			s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 
 		//! Draws an indexed triangle list.
 		/** Note that there may be at maximum 65536 vertices, because the
@@ -384,7 +384,7 @@
 		\param indexList: Pointer to array of indizes.
 		\param triangleCount: amount of Triangles. Usually amount of indizes / 3.*/
 		virtual void drawIndexedTriangleList(const S3DVertex2TCoords* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+			s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 
 		//! Draws an indexed triangle list.
 		/** Note that there may be at maximum 65536 vertices, because the
@@ -396,7 +396,7 @@
 		\param indexList: Pointer to array of indizes.
 		\param triangleCount: amount of Triangles. Usually amount of indizes / 3. */
 		virtual void drawIndexedTriangleList(const S3DVertexTangents* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+			s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 
 		//! Draws an indexed triangle fan.
 		/** Note that there may be at maximum 65536 vertices, because the
@@ -410,7 +410,7 @@
 		\param indexList: Pointer to array of indizes.
 		\param triangleCount: amount of Triangles. Usually amount of indizes - 2. */
 		virtual void drawIndexedTriangleFan(const S3DVertex* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+			s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 
 		//! Draws an indexed triangle fan.
 		/** Note that there may be at maximum 65536 vertices, because the
@@ -424,7 +424,7 @@
 		\param indexList: Pointer to array of indizes.
 		\param triangleCount: amount of Triangles. Usually amount of indizes - 2. */
 		virtual void drawIndexedTriangleFan(const S3DVertex2TCoords* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount) = 0;
+			s32 vertexCount, const u32* indexList, s32 triangleCount) = 0;
 
 		//! Draws a 3d line.
 		/** For some implementations, this method simply calls drawIndexedTriangles with some
diff -r -uw -N irrlicht/include/SMeshBuffer.h irrlicht_multipatch/include/SMeshBuffer.h
--- irrlicht/include/SMeshBuffer.h	2006-08-29 08:12:58.000000000 +0200
+++ irrlicht_multipatch/include/SMeshBuffer.h	2006-11-29 21:55:30.000000000 +0100
@@ -57,13 +57,13 @@
 		}
 
 		//! returns pointer to Indices
-		virtual const u16* getIndices() const
+		virtual const u32* getIndices() const
 		{
 			return Indices.const_pointer();
 		}
 
 		//! returns pointer to Indices
-		virtual u16* getIndices()
+		virtual u32* getIndices()
 		{
 			return Indices.pointer();
 		}
@@ -107,7 +107,7 @@
 
 		video::SMaterial Material; //! material for this meshBuffer.
 		core::array<video::S3DVertex> Vertices; //! Array of vertices
-		core::array<u16> Indices; //! Array of the Indices.
+		core::array<u32> Indices; //! Array of the Indices.
 		core::aabbox3d<f32> BoundingBox;
 	};
 
diff -r -uw -N irrlicht/include/SMeshBufferLightMap.h irrlicht_multipatch/include/SMeshBufferLightMap.h
--- irrlicht/include/SMeshBufferLightMap.h	2006-08-29 08:12:58.000000000 +0200
+++ irrlicht_multipatch/include/SMeshBufferLightMap.h	2006-11-29 21:56:34.000000000 +0100
@@ -58,13 +58,13 @@
 		}
 
 		//! returns pointer to Indices
-		virtual const u16* getIndices() const
+		virtual const u32* getIndices() const
 		{
 			return Indices.const_pointer();
 		}
 
 		//! returns pointer to Indices
-		virtual u16* getIndices()
+		virtual u32* getIndices()
 		{
 			return Indices.pointer();
 		}
@@ -108,7 +108,7 @@
 
 		video::SMaterial Material; //! material for this meshBuffer.
 		core::array<video::S3DVertex2TCoords> Vertices; //! Array of vertices
-		core::array<u16> Indices; //! Array of the Indices.
+		core::array<u32> Indices; //! Array of the Indices.
 		core::aabbox3d<f32> BoundingBox;
 	};
 
diff -r -uw -N irrlicht/include/SMeshBufferTangents.h irrlicht_multipatch/include/SMeshBufferTangents.h
--- irrlicht/include/SMeshBufferTangents.h	2006-08-29 08:12:58.000000000 +0200
+++ irrlicht_multipatch/include/SMeshBufferTangents.h	2006-11-29 21:57:30.000000000 +0100
@@ -57,13 +57,13 @@
 		}
 
 		//! returns pointer to Indices
-		virtual const u16* getIndices() const
+		virtual const u32* getIndices() const
 		{
 			return Indices.const_pointer();
 		}
 
 		//! returns pointer to Indices
-		virtual u16* getIndices()
+		virtual u32* getIndices()
 		{
 			return Indices.pointer();
 		}
@@ -107,7 +107,7 @@
 
 		video::SMaterial Material; //! material for this meshBuffer.
 		core::array<video::S3DVertexTangents> Vertices; //! Array of vertices
-		core::array<u16> Indices; //! Array of the Indices.
+		core::array<u32> Indices; //! Array of the Indices.
 		core::aabbox3d<f32> BoundingBox;
 	};
 
diff -r -uw -N irrlicht/include/irrlicht.h irrlicht_multipatch/include/irrlicht.h
--- irrlicht/include/irrlicht.h	2006-11-18 08:23:12.000000000 +0100
+++ irrlicht_multipatch/include/irrlicht.h	2006-11-30 17:25:28.000000000 +0100
@@ -279,6 +279,8 @@
 		IEventReceiver* receiver = 0,
 		const c8* sdk_version_do_not_use = IRRLICHT_SDK_VERSION);
 
+	IRRLICHT_API s32 IRRCALLCONV getMultiHeadAdapterCountDX9();
+
 	//! Creates an Irrlicht device with the option to specify advanced parameters. 
 	/** Usually you should used createDevice() for creating an Irrlicht Engine device.
 	Use this function only if you wish to specify advanced parameters like a window
diff -r -uw -N irrlicht/include/matrix4.h irrlicht_multipatch/include/matrix4.h
--- irrlicht/include/matrix4.h	2006-11-12 10:40:22.000000000 +0100
+++ irrlicht_multipatch/include/matrix4.h	2006-12-04 16:51:49.000000000 +0100
@@ -147,6 +147,12 @@
 			//! Builds a left-handed perspective projection matrix.
 			void buildProjectionMatrixPerspectiveLH(f32 widthOfViewVolume, f32 heightOfViewVolume, f32 zNear, f32 zFar);
 
+			//! Builds a right-handed perspective projection matrix.
+			void buildProjectionMatrixPerspectiveRH(f32 left, f32 right, f32 bottom, f32 top, f32 zNear, f32 zFar);
+
+			//! Builds a left-handed perspective projection matrix.
+			void buildProjectionMatrixPerspectiveLH(f32 left, f32 right, f32 bottom, f32 top, f32 zNear, f32 zFar);
+
 			//! Builds a left-handed orthogonal projection matrix.
 			void buildProjectionMatrixOrthoLH(f32 widthOfViewVolume, f32 heightOfViewVolume, f32 zNear, f32 zFar);
 
@@ -775,6 +781,55 @@
 	}
 
 
+	//! Builds a left-handed perspective projection matrix.
+	inline void matrix4::buildProjectionMatrixPerspectiveLH(f32 left, f32 right, f32 bottom, f32 top, f32 zNear, f32 zFar)
+	{
+		M[0] = 2*zNear/(right-left);
+		M[1] = 0;
+		M[2] = 0;
+		M[3] = 0;
+
+		M[4] = 0;
+		M[5] = 2*zNear/(top-bottom);
+		M[6] = 0;
+		M[7] = 0;
+
+		M[8] = (right+left)/(left-right);;
+		M[9] = (top+bottom)/(bottom-top);
+		M[10] = zFar/(zFar-zNear);
+		M[11] = 1;
+
+		M[12] = 0;
+		M[13] = 0;
+		M[14] = zNear*zFar/(zNear-zFar);
+		M[15] = 0;
+		
+	}
+
+	//! Builds a right-handed perspective projection matrix.
+	inline void matrix4::buildProjectionMatrixPerspectiveRH(f32 left, f32 right, f32 bottom, f32 top, f32 zNear, f32 zFar)
+	{
+		M[0] = 2*zNear/(right-left);
+		M[1] = 0;
+		M[2] = 0;
+		M[3] = 0;
+
+		M[4] = 0;
+		M[5] = 2*zNear/(top-bottom);
+		M[6] = 0;
+		M[7] = 0;
+
+		M[8] = (right+left)/(right-left);
+		M[9] = (top+bottom)/(top-bottom);
+		M[10] = zFar/(zNear-zFar);
+		M[11] = -1;
+
+		M[12] = 0;
+		M[13] = 0;
+		M[14] = zNear*zFar/(zNear-zFar);
+		M[15] = 0;
+	}
+
 	//! Builds a matrix that flattens geometry into a plane.
 	inline void matrix4::buildShadowMatrix(const core::vector3df& light, core::plane3df plane, f32 point)
 	{
diff -r -uw -N irrlicht/source/Irrlicht/C3DSMeshFileLoader.cpp irrlicht_multipatch/source/Irrlicht/C3DSMeshFileLoader.cpp
--- irrlicht/source/Irrlicht/C3DSMeshFileLoader.cpp	2006-11-12 10:40:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/C3DSMeshFileLoader.cpp	2006-11-29 23:49:34.000000000 +0100
@@ -1161,7 +1161,7 @@
 	group.faces = new s16[group.faceCount];
 	file->read(group.faces, sizeof(s16) * group.faceCount);
 #ifdef __BIG_ENDIAN__
-	for (int i=0;i<group.faceCount;i++) group.faces[i] = os::Byteswap::byteswap(group.faces[i]);
+	for (int i=0;i<group.faceCount;++i) group.faces[i] = os::Byteswap::byteswap(group.faces[i]);
 #endif
 	data.read += sizeof(s16) * group.faceCount;
 
@@ -1181,8 +1181,15 @@
 
 	// Indices are u16s.
 	// After every 3 Indices in the array, there follows an edge flag.
-	Indices = new u16[CountFaces * 4];
-	file->read(Indices, indexBufferByteSize);
+	u16 *l_indicies = new u16[CountFaces * 4];
+	file->read(l_indicies, indexBufferByteSize);
+
+	Indices = new u32[CountFaces * 4];
+
+	for (s32 idx = 0; idx < CountFaces*4; ++idx) 
+		Indices[idx] = l_indicies[idx];
+	delete []l_indicies;
+
 #ifdef __BIG_ENDIAN__
 	for (int i=0;i<CountFaces*4;++i) Indices[i] = os::Byteswap::byteswap(Indices[i]);
 #endif
diff -r -uw -N irrlicht/source/Irrlicht/C3DSMeshFileLoader.h irrlicht_multipatch/source/Irrlicht/C3DSMeshFileLoader.h
--- irrlicht/source/Irrlicht/C3DSMeshFileLoader.h	2006-07-15 08:41:48.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/C3DSMeshFileLoader.h	2006-11-29 22:27:46.000000000 +0100
@@ -155,7 +155,7 @@
 	video::IVideoDriver* Driver;
 
 	f32* Vertices;
-	u16* Indices;
+	u32* Indices;
 	core::array<u16> TempIndices;
 	f32* TCoords;
 	u16 CountVertices;
diff -r -uw -N irrlicht/source/Irrlicht/CAnimatedMeshB3d.h irrlicht_multipatch/source/Irrlicht/CAnimatedMeshB3d.h
--- irrlicht/source/Irrlicht/CAnimatedMeshB3d.h	2006-09-24 11:30:56.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CAnimatedMeshB3d.h	2006-11-29 22:33:56.000000000 +0100
@@ -139,12 +139,12 @@
 				return Vertices.size();
 			}
 
-			virtual const u16* getIndices() const
+			virtual const u32* getIndices() const
 			{
 				return Indices.const_pointer();
 			}
 
-			virtual u16* getIndices()
+			virtual u32* getIndices()
 			{
 				return Indices.pointer();
 			}
@@ -183,7 +183,7 @@
 
 			video::SMaterial Material;
 			core::array<video::S3DVertex2TCoords> Vertices;
-			core::array<u16> Indices;
+			core::array<u32> Indices;
 			core::aabbox3d<f32> BoundingBox;
 		};
 
diff -r -uw -N irrlicht/source/Irrlicht/CAnimatedMeshMD2.cpp irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMD2.cpp
--- irrlicht/source/Irrlicht/CAnimatedMeshMD2.cpp	2006-09-24 11:30:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMD2.cpp	2006-11-29 22:41:16.000000000 +0100
@@ -399,7 +399,7 @@
 
 
 //! returns pointer to Indices
-const u16* CAnimatedMeshMD2::getIndices() const
+const u32* CAnimatedMeshMD2::getIndices() const
 {
 	return Indices.const_pointer();
 }
@@ -407,7 +407,7 @@
 
 
 //! returns pointer to Indices
-u16* CAnimatedMeshMD2::getIndices()
+u32* CAnimatedMeshMD2::getIndices()
 {
 	return Indices.pointer();
 }
diff -r -uw -N irrlicht/source/Irrlicht/CAnimatedMeshMD2.h irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMD2.h
--- irrlicht/source/Irrlicht/CAnimatedMeshMD2.h	2006-08-29 08:13:00.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMD2.h	2006-11-29 22:40:34.000000000 +0100
@@ -60,10 +60,10 @@
 		virtual s32 getVertexCount() const;
 
 		//! returns pointer to Indices
-		virtual const u16* getIndices() const;
+		virtual const u32* getIndices() const;
 
 		//! returns pointer to Indices
-		virtual u16* getIndices();
+		virtual u32* getIndices();
 
 		//! returns amount of indices
 		virtual s32 getIndexCount() const;
@@ -112,7 +112,7 @@
 		//! calculates normals
 		void calculateNormals();
 
-		core::array<u16> Indices;
+		core::array<u32> Indices;
 		core::array<video::S3DVertex> *FrameList;
 		core::array<core::aabbox3d<f32> > BoxList;
 		u32 FrameCount;
diff -r -uw -N irrlicht/source/Irrlicht/CAnimatedMeshMS3D.cpp irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMS3D.cpp
--- irrlicht/source/Irrlicht/CAnimatedMeshMS3D.cpp	2006-11-18 08:23:12.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMS3D.cpp	2006-11-29 22:56:04.000000000 +0100
@@ -471,7 +471,7 @@
 		if (grp.MaterialIdx >= Buffers.size()) 
 			grp.MaterialIdx = 0; 
 
-		core::array<u16>& indices = Buffers[grp.MaterialIdx].Indices;
+		core::array<u32>& indices = Buffers[grp.MaterialIdx].Indices;
 
 		for (u32 k=0; k<grp.VertexIds.size(); ++k)
 			for (u32 l=0; l<3; ++l)
@@ -736,13 +736,13 @@
 } 
 
 //! returns pointer to Indices 
-const u16* CAnimatedMeshMS3D::SMS3DMeshBuffer::getIndices() const 
+const u32* CAnimatedMeshMS3D::SMS3DMeshBuffer::getIndices() const 
 { 
 	return Indices.const_pointer(); 
 } 
 
 //! returns pointer to Indices 
-u16* CAnimatedMeshMS3D::SMS3DMeshBuffer::getIndices() 
+u32* CAnimatedMeshMS3D::SMS3DMeshBuffer::getIndices() 
 { 
 	return Indices.pointer(); 
 } 
diff -r -uw -N irrlicht/source/Irrlicht/CAnimatedMeshMS3D.h irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMS3D.h
--- irrlicht/source/Irrlicht/CAnimatedMeshMS3D.h	2006-08-29 08:13:00.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CAnimatedMeshMS3D.h	2006-11-29 22:49:34.000000000 +0100
@@ -131,10 +131,10 @@
 			virtual s32 getVertexCount() const;
 
 			//! returns pointer to Indices 
-			virtual const u16* getIndices() const;
+			virtual const u32* getIndices() const;
 
 			//! returns pointer to Indices 
-			virtual u16* getIndices();
+			virtual u32* getIndices();
 
 			//! returns amount of indices 
 			virtual s32 getIndexCount() const;
@@ -150,7 +150,7 @@
 
 			video::SMaterial Material;                  //! material for this meshBuffer. 
 			core::array<video::S3DVertex> *Vertices;      //! Array of vertices 
-			core::array<u16> Indices;   //! Array of the Indices. 
+			core::array<u32> Indices;   //! Array of the Indices. 
 			core::aabbox3d<f32> *BoundingBox; 
 		}; 
 
@@ -161,7 +161,7 @@
 
 		core::array<video::S3DVertex> Vertices;
 		core::array<video::S3DVertex> AnimatedVertices;
-		core::array<u16> Indices;
+		core::array<u32> Indices;
 		
 		core::array<SJoint> Joints;
 		core::array<SGroup> Groups;
diff -r -uw -N irrlicht/source/Irrlicht/CBillboardSceneNode.h irrlicht_multipatch/source/Irrlicht/CBillboardSceneNode.h
--- irrlicht/source/Irrlicht/CBillboardSceneNode.h	2006-06-17 08:11:42.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CBillboardSceneNode.h	2006-11-29 23:20:36.000000000 +0100
@@ -61,7 +61,7 @@
 	video::SMaterial Material;
 
 	video::S3DVertex vertices[4];
-	u16 indices[6];
+	u32 indices[6];
 };
 
 
diff -r -uw -N irrlicht/source/Irrlicht/CCubeSceneNode.cpp irrlicht_multipatch/source/Irrlicht/CCubeSceneNode.cpp
--- irrlicht/source/Irrlicht/CCubeSceneNode.cpp	2006-08-29 08:13:00.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CCubeSceneNode.cpp	2006-11-29 23:22:12.000000000 +0100
@@ -22,7 +22,7 @@
 	setDebugName("CCubeSceneNode");
 	#endif
 
-	u16 u[36] = {   0,2,1,   0,3,2,   1,5,4,   1,2,5,   4,6,7,   4,5,6, 
+	u32 u[36] = {   0,2,1,   0,3,2,   1,5,4,   1,2,5,   4,6,7,   4,5,6, 
             7,3,0,   7,6,3,   9,5,2,   9,8,5,   0,11,10,   0,10,7};
 
 	Buffer.Indices.set_used(36);
diff -r -uw -N irrlicht/source/Irrlicht/CD3D8Driver.cpp irrlicht_multipatch/source/Irrlicht/CD3D8Driver.cpp
--- irrlicht/source/Irrlicht/CD3D8Driver.cpp	2006-11-01 08:01:48.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CD3D8Driver.cpp	2006-12-05 11:58:39.000000000 +0100
@@ -271,7 +271,7 @@
 	}
 
 	if (!StencilBuffer)
-		present.AutoDepthStencilFormat = D3DFMT_D24X8;
+		present.AutoDepthStencilFormat = D3DFMT_D16;
 
 	// create device
 
@@ -488,7 +488,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool CD3D8Driver::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool CD3D8Driver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	switch (feature)
 	{
@@ -754,7 +754,7 @@
 
 
 //! draws a vertex primitive list
-void CD3D8Driver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void CD3D8Driver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
 	if (!checkPrimitiveCount(primitiveCount))
 		return;
@@ -785,16 +785,16 @@
 		{
 		   case scene::EPT_POINTS:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_POINTLIST, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		   case scene::EPT_LINE_STRIP:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		   case scene::EPT_LINE_LOOP:
 		   {
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINESTRIP, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  u16 tmpIndices[] = {0, primitiveCount};
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
 				 1, tmpIndices, D3DFMT_INDEX16, vertices, stride);
@@ -802,19 +802,19 @@
 			  break;
 		   case scene::EPT_LINES:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_LINELIST, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		   case scene::EPT_TRIANGLE_STRIP:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLESTRIP, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		   case scene::EPT_TRIANGLE_FAN:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLEFAN, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		   case scene::EPT_TRIANGLES:
 			  pID3DDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, vertexCount,
-				 primitiveCount, indexList, D3DFMT_INDEX16, vertices, stride);
+				 primitiveCount, indexList, D3DFMT_INDEX32, vertices, stride);
 			  break;
 		}
 	}
diff -r -uw -N irrlicht/source/Irrlicht/CD3D8Driver.h irrlicht_multipatch/source/Irrlicht/CD3D8Driver.h
--- irrlicht/source/Irrlicht/CD3D8Driver.h	2006-10-15 08:48:48.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D8Driver.h	2006-12-05 11:49:16.000000000 +0100
@@ -46,7 +46,7 @@
 		virtual bool endScene( s32 windowId, core::rect<s32>* sourceRect=0 );
 
 		//! queries the features of the driver, returns true if feature is available
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! sets transformation
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
@@ -66,7 +66,7 @@
 		virtual const core::rect<s32>& getViewPort() const;
 
 		//! draws a vertex primitive list
-		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! draws an 2d image, using a color (if color is other then Color(255,255,255,255)) and the alpha channel of the texture if wanted.
 		virtual void draw2DImage(video::ITexture* texture, const core::position2d<s32>& destPos,
